package com.lightinit.hsdatashow.impl.ms;

import com.lightinit.hsdatashow.entity.BaseExample;
import com.lightinit.hsdatashow.entity.PopulationSummary;
import com.lightinit.hsdatashow.entity.PopulationSummaryExample;
import com.lightinit.hsdatashow.mapper.PopulationSummaryMapper;
import com.lightinit.hsdatashow.model.ResultState;
import com.lightinit.hsdatashow.model.ResultStateCode;
import com.lightinit.hsdatashow.service.ms.IMSPeopleGrowthService;
import com.lightinit.hsdatashow.spring.DynamicDataContextHolder;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class MSPeopleGrowthServiceImpl implements IMSPeopleGrowthService {
    @Autowired
    private PopulationSummaryMapper populationSummaryMapper;
    @Override
    public List<PopulationSummary> queryList(BaseExample.Page pager) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        PopulationSummaryExample example = new PopulationSummaryExample();
        example.setPage(pager);
        return populationSummaryMapper.selectByExample(example);
    }

    @Override
    public long queryCount(BaseExample.Page pager) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        PopulationSummaryExample example = new PopulationSummaryExample();
        example.setPage(pager);
        return populationSummaryMapper.countByExample(example);
    }

    @Override
    public ResultState<Long> delete(long id) {
        ResultState<Long> resultState = new ResultState<Long>();
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        if (!(populationSummaryMapper.deleteByPrimaryKey(id)>0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据不存在");
        }
        resultState.setData(id);
        return resultState;
    }

    @Override
    public ResultState add(PopulationSummary inputModel) {
        ResultState<Long> resultState = new ResultState<Long>();
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        inputModel.setCreatedAt(new Date());
        PopulationSummary entity = new PopulationSummary();
        BeanUtils.copyProperties(inputModel, entity);
        long sqlResult = populationSummaryMapper.insert(entity);
        if (!(sqlResult > 0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据插入失败");
        }
        resultState.setData(entity.getId());
        return resultState;
    }

    @Override
    public PopulationSummary edit(long id) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        return populationSummaryMapper.selectByPrimaryKey(id);
    }

    @Override
    public ResultState doEdit(PopulationSummary inputModel) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        ResultState<Long> resultState = new ResultState<Long>();
        if (!(populationSummaryMapper.updateByPrimaryKey(inputModel)>0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据不存在");
        }
        resultState.setData(inputModel.getId());
        return resultState;
    }
}
